var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import WS from 'jest-websocket-mock';
import NotificationAPI from '../index';
var clientId = 'envId@';
var userId = 'userId@';
var spy;
var notificationapi;
var server;
beforeEach(function () {
    spy = jest.spyOn(console, 'error').mockImplementation();
    server = new WS('ws://localhost:1235', { jsonProtocol: true });
    notificationapi = new NotificationAPI({
        clientId: clientId,
        userId: userId,
        websocket: 'ws://localhost:1235'
    });
});
afterEach(function () {
    WS.clean();
    spy.mockRestore();
    if (notificationapi)
        notificationapi.destroy();
});
describe('given connection is already open', function () {
    beforeEach(function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, server.connected];
                case 1:
                    _a.sent();
                    return [4, server.nextMessage];
                case 2:
                    _a.sent();
                    return [2];
            }
        });
    }); });
    test('sends a user_preferences/preferences message', function () { return __awaiter(void 0, void 0, void 0, function () {
        var request;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    notificationapi.getUserPreferences();
                    request = {
                        route: 'user_preferences/get_preferences'
                    };
                    return [4, expect(server).toReceiveMessage(request)];
                case 1:
                    _a.sent();
                    return [2];
            }
        });
    }); });
    test('resolves and returns the payload of the user_preferences response', function () { return __awaiter(void 0, void 0, void 0, function () {
        var response, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    response = {
                        route: 'user_preferences/preferences',
                        payload: {
                            userPreferences: []
                        }
                    };
                    server.nextMessage.then(function () { return server.send(response); });
                    return [4, notificationapi.getUserPreferences()];
                case 1:
                    result = _a.sent();
                    expect(result).toEqual([]);
                    return [2];
            }
        });
    }); });
    test('does not resolve with other messages', function () { return __awaiter(void 0, void 0, void 0, function () {
        var response1, response2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    response1 = {
                        route: 'inapp_web/unread_count',
                        payload: {
                            count: 0
                        }
                    };
                    response2 = {
                        route: 'user_preferences/preferences',
                        payload: {
                            userPreferences: []
                        }
                    };
                    notificationapi.getUserPreferences().then(function (result) {
                        expect(result).toEqual([]);
                    });
                    return [4, server.send(response1)];
                case 1:
                    _a.sent();
                    return [4, new Promise(function (resolve) { return setTimeout(resolve, 200); })];
                case 2:
                    _a.sent();
                    return [4, server.send(response2)];
                case 3:
                    _a.sent();
                    return [2];
            }
        });
    }); });
});
describe('given connection is not open yet', function () {
    test('sends request and resolves after connection is open', function () { return __awaiter(void 0, void 0, void 0, function () {
        var response, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, server.nextMessage];
                case 1:
                    _a.sent();
                    response = {
                        route: 'user_preferences/preferences',
                        payload: {
                            userPreferences: []
                        }
                    };
                    server.nextMessage.then(function (message) {
                        expect(message).toEqual({
                            route: 'user_preferences/get_preferences'
                        });
                        server.send(response);
                    });
                    return [4, notificationapi.getUserPreferences()];
                case 2:
                    result = _a.sent();
                    expect(result).toEqual([]);
                    return [2];
            }
        });
    }); });
});
describe('given no websocket', function () {
    test('rejects the promise when websocket is not present', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    notificationapi = new NotificationAPI({
                        clientId: '',
                        userId: '',
                        websocket: false
                    });
                    return [4, expect(notificationapi.getUserPreferences()).rejects.toEqual('Websocket is not present.')];
                case 1:
                    _a.sent();
                    return [2];
            }
        });
    }); });
    test('rejects the promise when websocket fails to open', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    server.error();
                    notificationapi = new NotificationAPI({
                        clientId: clientId,
                        userId: userId,
                        websocket: 'ws://localhost:1235'
                    });
                    return [4, expect(notificationapi.getUserPreferences()).rejects.toEqual('Websocket failed to open.')];
                case 1:
                    _a.sent();
                    return [2];
            }
        });
    }); });
});
