var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import WS from 'jest-websocket-mock';
import NotificationAPI from '../index';
var clientId = 'envId@';
var userId = 'userId@';
var userIdHash = 'userIdHash@';
var spy;
var notificationapi;
beforeEach(function () {
    spy = jest.spyOn(console, 'error').mockImplementation();
    document.body.innerHTML = '<div id="root"></div><div id="root2"></div>';
});
afterEach(function () {
    WS.clean();
    spy.mockRestore();
    if (notificationapi)
        notificationapi.destroy();
});
test('init returns an error on bad clientId', function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        notificationapi = new NotificationAPI({
            clientId: ['somearray'][2],
            userId: userId
        });
        notificationapi = new NotificationAPI({
            clientId: '',
            userId: userId
        });
        notificationapi = new NotificationAPI({
            clientId: 'undefined',
            userId: userId
        });
        expect(spy.mock.calls).toEqual([
            ['Invalid clientId.'],
            ['Invalid clientId.'],
            ['Invalid clientId.']
        ]);
        return [2];
    });
}); });
test('init returns an error on bad userId', function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        notificationapi = new NotificationAPI({
            clientId: clientId,
            userId: ['somearray'][2]
        });
        notificationapi = new NotificationAPI({
            clientId: clientId,
            userId: ''
        });
        notificationapi = new NotificationAPI({
            clientId: clientId,
            userId: 'undefined'
        });
        expect(spy.mock.calls).toEqual([
            ['Invalid userId.'],
            ['Invalid userId.'],
            ['Invalid userId.']
        ]);
        return [2];
    });
}); });
test('init returns a NotificationAPIClient object and adds to window', function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        notificationapi = new NotificationAPI({
            clientId: clientId,
            userId: userId
        });
        expect(notificationapi).toBeTruthy();
        return [2];
    });
}); });
test('given custom websocket, requests connection URL with UserId and envId', function () { return __awaiter(void 0, void 0, void 0, function () {
    var server, requestedURL;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                server = new WS('ws://localhost:1234', { jsonProtocol: true });
                notificationapi = new NotificationAPI({
                    websocket: 'ws://localhost:1234',
                    clientId: clientId,
                    userId: userId
                });
                requestedURL = '';
                server.on('connection', function (socket) {
                    requestedURL = socket.url;
                });
                return [4, server.connected];
            case 1:
                _a.sent();
                expect(requestedURL).toBe("ws://localhost:1234/?envId=".concat(encodeURIComponent(clientId), "&userId=").concat(encodeURIComponent(userId)));
                return [2];
        }
    });
}); });
test('given custom websocket & userIdHash, requests connection URL with encoded UserId, envId and userIdHash', function () { return __awaiter(void 0, void 0, void 0, function () {
    var server, requestedURL;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                server = new WS('ws://localhost:1234', { jsonProtocol: true });
                notificationapi = new NotificationAPI({
                    websocket: 'ws://localhost:1234',
                    clientId: clientId,
                    userId: userId,
                    userIdHash: userIdHash
                });
                requestedURL = '';
                server.on('connection', function (socket) {
                    requestedURL = socket.url;
                });
                return [4, server.connected];
            case 1:
                _a.sent();
                expect(requestedURL).toBe("ws://localhost:1234/?envId=".concat(encodeURIComponent(clientId), "&userId=").concat(encodeURIComponent(userId), "&userIdHash=").concat(encodeURIComponent(userIdHash)));
                return [2];
        }
    });
}); });
test('given websocket:false, websocket is not opened', function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        notificationapi = new NotificationAPI({
            clientId: clientId,
            userId: userId,
            websocket: false
        });
        expect(notificationapi.websocket).toBeFalsy();
        return [2];
    });
}); });
