var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import $ from 'jquery';
import { PopupPosition, MarkAsReadModes } from '../interfaces';
import WS from 'jest-websocket-mock';
import NotificationAPI from '../index';
import { generateFakeNotifications } from './FakeNotificationGenerator';
var testNotification = {
    id: '1',
    seen: true,
    title: 'You have a new comment',
    redirectURL: 'https://www.notificationapi.com',
    imageURL: 'https://via.placeholder.com/350x150',
    date: new Date().toISOString()
};
var testNotificationWithoutImage = {
    id: '2',
    seen: true,
    title: 'You have a new comment',
    redirectURL: 'https://www.notificationapi.com',
    date: new Date().toISOString()
};
var testNotificationWithoutURL = {
    id: '3',
    seen: true,
    title: 'You have a new comment',
    imageURL: 'https://via.placeholder.com/350x150',
    date: new Date().toISOString()
};
var testNotificationUnseen = {
    id: '4',
    seen: false,
    title: 'You have a new comment',
    date: new Date().toISOString()
};
var timeCases_seconds = [
    -100,
    -10,
    10,
    1 * 60,
    2 * 60,
    1 * 60 * 60,
    2 * 60 * 60,
    1 * 60 * 60 * 24,
    2 * 60 * 60 * 24,
    1 * 60 * 60 * 24 * 30,
    2 * 60 * 60 * 24 * 30,
    1 * 60 * 60 * 24 * 30 * 365.25,
    2 * 60 * 60 * 24 * 30 * 365.25
].map(function (item, index) {
    return index > 2 ? item * 1000 : item;
});
var notificationWithDifferentTimes = timeCases_seconds.map(function (timeCase_seconds, index) {
    return {
        id: "".concat(5 + index),
        seen: true,
        title: 'You have a new comment',
        redirectURL: 'https://www.notificationapi.com',
        imageURL: 'https://via.placeholder.com/350x150',
        date: new Date(Date.now() - timeCase_seconds).toISOString()
    };
});
var timeCasesResults = [
    'just now',
    'just now',
    'just now',
    '1 minute ago',
    '2 minutes ago',
    '1 hour ago',
    '2 hours ago',
    '1 day ago',
    '2 days ago',
    '1 month ago',
    '2 months ago',
    '1 year ago',
    '2 years ago'
];
var fiftyNotifs = [];
for (var i = 0; i < 50; i++) {
    fiftyNotifs[i] = __assign(__assign({}, testNotification), { id: i.toString() });
}
var clientId = 'envId@';
var userId = 'userId@';
var spy;
var notificationapi;
var server;
beforeEach(function () {
    spy = jest.spyOn(console, 'error').mockImplementation();
    document.body.innerHTML =
        '<div id="root"></div><div id="root2"></div><div id="somethingelse">somethingelse</div>';
    Object.defineProperty(window, 'innerWidth', {
        writable: true,
        configurable: true,
        value: 1600
    });
    server = new WS('ws://localhost:1234', { jsonProtocol: true });
    notificationapi = new NotificationAPI({
        clientId: clientId,
        userId: userId,
        websocket: 'ws://localhost:1234'
    });
});
afterEach(function () {
    WS.clean();
    spy.mockRestore();
    if (notificationapi)
        notificationapi.destroy();
});
describe('defaults', function () {
    test('given bad root element shows error', function () {
        notificationapi.showInApp({
            root: 'none'
        });
        expect(spy.mock.calls).toEqual([
            ['There are no HTML elements with id="none" on the page.']
        ]);
    });
    test('given bad popupPosition, throws error', function () {
        notificationapi.showInApp({
            root: 'root',
            popupPosition: 'blah'
        });
        expect(spy.mock.calls).toEqual([
            [
                '"blah" is not a valid position. Valid positions: topLeft, topRight, leftTop, leftBottom, bottomLeft, bottomRight, rightTop, rightBottom'
            ]
        ]);
    });
    test('adds the a notificationapi container to the root', function () {
        notificationapi.showInApp({
            root: 'root'
        });
        expect($('[id="root"] > .notificationapi-container')).toHaveLength(1);
    });
    test('adds the notification popup button to the container', function () {
        notificationapi.showInApp({
            root: 'root'
        });
        expect($('.notificationapi-container > .notificationapi-button')).toHaveLength(1);
    });
    test('adds the notification popup to the container with .hovering.closed', function () {
        notificationapi.showInApp({
            root: 'root'
        });
        expect($('.notificationapi-container > .notificationapi-popup.popup.hovering.closed:not(.inline)')).toHaveLength(1);
    });
    test('given no WS, throws no error', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            notificationapi = new NotificationAPI({
                clientId: clientId,
                userId: userId,
                websocket: false
            });
            notificationapi.showInApp({
                root: 'root'
            });
            expect(spy.mock.calls).toEqual([]);
            return [2];
        });
    }); });
});
describe('When askForWebPushPermission and localStorage is set true', function () {
    var notificationAPI;
    var askForWebPushPermissionSpy;
    beforeEach(function () {
        var settings = true;
        Storage.prototype.getItem = jest.fn(function () { return JSON.stringify(settings); });
        server.connected;
        notificationapi.showInApp({
            root: 'root'
        });
        var res = {
            route: 'environment/data',
            payload: {
                logo: 'string',
                applicationServerKey: 'string',
                askForWebPushPermission: true
            }
        };
        server.send(res);
        askForWebPushPermissionSpy = jest.spyOn(notificationapi, 'askForWebPushPermission');
    });
    afterEach(function () {
        jest.restoreAllMocks();
        if (notificationAPI)
            notificationAPI.destroy();
    });
    test('opt-in message is displayed', function () {
        expect($('.notificationapi-opt-in-container')[0].style.display).toEqual('');
    });
    describe('When opt-in YES is clicked,', function () {
        test('opt-in message is not displayed ', function () {
            $('.notificationapi-allow-button').trigger('click');
            expect($('.notificationapi-opt-in-container')[0].style.display).toEqual('none');
        });
        test(' askForWebPushPermission function is called', function () {
            $('.notificationapi-allow-button').trigger('click');
            expect(askForWebPushPermissionSpy).toHaveBeenCalledWith();
        });
    });
    describe('When No thanks button click', function () {
        test('opt-in message is not displayed ', function () {
            expect($('.notificationapi-opt-in-container')[0].style.display).toEqual('');
            $('.notificationapi-no-thanks-button').trigger('click');
            expect($('.notificationapi-opt-in-container')[0].style.display).toEqual('none');
        });
    });
});
describe('When askForWebPushPermission and localStorage is not set', function () {
    var notificationAPI;
    beforeEach(function () {
        Storage.prototype.getItem = jest.fn(function () { return null; });
        server.connected;
        notificationapi.showInApp({
            root: 'root'
        });
        var res = {
            route: 'environment/data',
            payload: {
                logo: 'string',
                applicationServerKey: 'string',
                askForWebPushPermission: false
            }
        };
        server.send(res);
    });
    afterEach(function () {
        jest.restoreAllMocks();
        if (notificationAPI)
            notificationAPI.destroy();
    });
    test('no notificationapi-opt-in-container', function () {
        expect($('.notificationapi-opt-in-container').length).toEqual(0);
    });
});
describe('When the notification permission is already granted', function () {
    var notificationAPI;
    beforeEach(function () {
        Storage.prototype.getItem = jest.fn(function () { return 'true'; });
        global.Notification = {
            permission: 'granted',
            requestPermission: jest.fn()
        };
        server.connected;
        var res = {
            route: 'environment/data',
            payload: {
                logo: 'string',
                applicationServerKey: 'string',
                askForWebPushPermission: true
            }
        };
        server.send(res);
        notificationapi.showInApp({
            root: 'root'
        });
    });
    afterEach(function () {
        jest.restoreAllMocks();
        if (notificationAPI)
            notificationAPI.destroy();
    });
    test('no notificationapi-opt-in-container', function () {
        expect($('.notificationapi-opt-in-container').length).toEqual(0);
    });
});
describe('inline mode', function () {
    test('inline mode: adds a notification popup to the container with .inline', function () {
        notificationapi.showInApp({
            root: 'root',
            inline: true
        });
        expect($('.notificationapi-container > .notificationapi-popup.inline:not(.popup)')).toHaveLength(1);
    });
    test('inline mode: openInAppPopup and closeInAppPopup do not change popup style or throw error', function () {
        notificationapi.showInApp({
            root: 'root',
            inline: true
        });
        var classes = $('.notificationapi-popup')[0].classList;
        notificationapi.openInAppPopup();
        expect($('.notificationapi-popup')[0].classList).toEqual(classes);
        notificationapi.closeInAppPopup();
        expect($('.notificationapi-popup')[0].classList).toEqual(classes);
        expect(spy.mock.calls).toEqual([]);
    });
});
describe('popup interactions', function () {
    test('when button is clicked, popup has .hovering not .closed', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            notificationapi.showInApp({
                root: 'root'
            });
            $('.notificationapi-button').trigger('click');
            expect($('.notificationapi-popup').hasClass('hovering'));
            expect($('.notificationapi-popup').hasClass('closed')).toBeFalsy();
            return [2];
        });
    }); });
    test('when button is clicked, unread badge is removed and requests clearing unread', function () { return __awaiter(void 0, void 0, void 0, function () {
        var expectedMsg;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, server.nextMessage];
                case 1:
                    _a.sent();
                    notificationapi.showInApp({
                        root: 'root'
                    });
                    return [4, server.nextMessage];
                case 2:
                    _a.sent();
                    return [4, server.nextMessage];
                case 3:
                    _a.sent();
                    $('.notificationapi-button').trigger('click');
                    expectedMsg = {
                        route: 'inapp_web/unread_clear'
                    };
                    expect($('.notificationapi-unread').hasClass('hidden')).toBeTruthy();
                    return [4, expect(server).toReceiveMessage(expectedMsg)];
                case 4:
                    _a.sent();
                    return [2];
            }
        });
    }); });
    test('when button is clicked then clicked again, popup has .closed', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            notificationapi.showInApp({
                root: 'root'
            });
            $('.notificationapi-button').trigger('click');
            $('.notificationapi-button').trigger('click');
            expect($('.notificationapi-popup').hasClass('closed'));
            return [2];
        });
    }); });
    test('when button is clicked then popup content is clicked, popup is not .closed', function () {
        notificationapi.showInApp({
            root: 'root'
        });
        $('.notificationapi-button').trigger('click');
        $('.notificationapi-header').trigger('click');
        expect($('.notificationapi-popup').hasClass('closed')).toBeFalsy();
    });
    test('when button is clicked then page clicked, popup has .closed', function () {
        notificationapi.showInApp({
            root: 'root'
        });
        $('.notificationapi-button').trigger('click');
        $('body').trigger('click');
        expect($('.notificationapi-popup').hasClass('closed'));
    });
    test('when button is clicked then header close button clicked, popup has .closed', function () {
        notificationapi.showInApp({
            root: 'root'
        });
        $('.notificationapi-button').trigger('click');
        $('.notificationapi-header .notificationapi-close-button').trigger('click');
        expect($('.notificationapi-popup').hasClass('closed'));
    });
    test('when button is clicked, then preferences button is clicked, calls showUserPreferences', function () {
        notificationapi.showInApp({
            root: 'root'
        });
        spy = jest
            .spyOn(notificationapi, 'showUserPreferences')
            .mockImplementation();
        $('.notificationapi-button').trigger('click');
        $('.notificationapi-header .notificationapi-preferences-button').trigger('click');
        expect(spy.mock.calls).toHaveLength(1);
    });
    test('when button is clicked, then preferences button is clicked, then anything in preferences are clicked, popup is not .closed', function () {
        notificationapi.showInApp({
            root: 'root'
        });
        $('.notificationapi-button').trigger('click');
        $('.notificationapi-preferences-button').trigger('click');
        $('.notificationapi-preferences-container').trigger('click');
        expect($('.notificationapi-popup').hasClass('closed')).toBeFalsy();
    });
    test('works with all different popupPosition variations', function () {
        Object.values(PopupPosition).map(function (popupPosition) {
            notificationapi.showInApp({
                root: 'root',
                popupPosition: popupPosition
            });
            $('.notificationapi-button').trigger('click');
            expect(spy.mock.calls).toEqual([]);
        });
    });
    test('works in screens smaller than 768', function () {
        Object.defineProperty(window, 'innerWidth', {
            writable: true,
            configurable: true,
            value: 767
        });
        notificationapi.showInApp({
            root: 'root'
        });
        $('.notificationapi-button').trigger('click');
        expect(spy.mock.calls).toEqual([]);
    });
    test('after receiving >=50 notifications, scrolling to the end triggers requesting 50 more before the oldest notification', function () { return __awaiter(void 0, void 0, void 0, function () {
        var res, req4;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    notificationapi.showInApp({
                        root: 'root'
                    });
                    return [4, server.nextMessage];
                case 1:
                    _a.sent();
                    return [4, server.nextMessage];
                case 2:
                    _a.sent();
                    return [4, server.nextMessage];
                case 3:
                    _a.sent();
                    fiftyNotifs[49] = __assign(__assign({}, testNotification), { id: '49', date: '1989-09-28T10:00:00.000Z' });
                    res = {
                        route: 'inapp_web/notifications',
                        payload: {
                            notifications: fiftyNotifs
                        }
                    };
                    server.send(res);
                    $('.notificationapi-button').trigger('click');
                    return [4, server.nextMessage];
                case 4:
                    _a.sent();
                    $('.notificationapi-popup-inner')[0].dispatchEvent(new CustomEvent('scroll'));
                    req4 = {
                        route: 'inapp_web/notifications',
                        payload: {
                            before: '1989-09-28T10:00:00.000Z',
                            count: 50
                        }
                    };
                    return [4, expect(server).toReceiveMessage(req4)];
                case 5:
                    _a.sent();
                    return [2];
            }
        });
    }); });
    test('after receiving >=50 notifications, after scrolling and requesting more, scrolling quickly again does not trigger requesting more', function () { return __awaiter(void 0, void 0, void 0, function () {
        var res;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    notificationapi.showInApp({
                        root: 'root'
                    });
                    return [4, server.nextMessage];
                case 1:
                    _a.sent();
                    return [4, server.nextMessage];
                case 2:
                    _a.sent();
                    res = {
                        route: 'inapp_web/notifications',
                        payload: {
                            notifications: fiftyNotifs
                        }
                    };
                    server.send(res);
                    $('.notificationapi-button').trigger('click');
                    return [4, server.nextMessage];
                case 3:
                    _a.sent();
                    $('.notificationapi-popup-inner')[0].dispatchEvent(new CustomEvent('scroll'));
                    $('.notificationapi-popup-inner')[0].dispatchEvent(new CustomEvent('scroll'));
                    $('.notificationapi-popup-inner')[0].dispatchEvent(new CustomEvent('scroll'));
                    return [4, new Promise(function (resolve) { return setTimeout(resolve, 1000); })];
                case 4:
                    _a.sent();
                    expect(server.messages).toHaveLength(5);
                    return [2];
            }
        });
    }); });
    test('after receiving <50 notifications, scrolling does not trigger requetsing more', function () { return __awaiter(void 0, void 0, void 0, function () {
        var res;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    notificationapi.showInApp({
                        root: 'root'
                    });
                    return [4, server.nextMessage];
                case 1:
                    _a.sent();
                    return [4, server.nextMessage];
                case 2:
                    _a.sent();
                    return [4, server.nextMessage];
                case 3:
                    _a.sent();
                    res = {
                        route: 'inapp_web/notifications',
                        payload: {
                            notifications: [testNotification]
                        }
                    };
                    server.send(res);
                    $('.notificationapi-button').trigger('click');
                    return [4, server.nextMessage];
                case 4:
                    _a.sent();
                    $('.notificationapi-popup-inner')[0].dispatchEvent(new CustomEvent('scroll'));
                    return [4, new Promise(function (resolve) { return setTimeout(resolve, 1000); })];
                case 5:
                    _a.sent();
                    expect(server.messages).toHaveLength(4);
                    expect($('.notificationapi-nomore')).toHaveLength(1);
                    return [2];
            }
        });
    }); });
});
describe('setUnread', function () {
    test('doesnt not display or break in inline mode', function () {
        notificationapi.showInApp({
            root: 'root',
            inline: true
        });
        notificationapi.setInAppUnread(123);
        expect($('.notificationapi-unread')).toHaveLength(0);
        expect(spy.mock.calls).toHaveLength(0);
    });
    test('given 0, is not displayed', function () {
        notificationapi.showInApp({
            root: 'root'
        });
        notificationapi.setInAppUnread(0);
        expect($('.notificationapi-unread').hasClass('hidden')).toBeTruthy();
    });
    test('given 1, shows 1', function () {
        notificationapi.showInApp({
            root: 'root'
        });
        notificationapi.setInAppUnread(1);
        expect($('.notificationapi-unread').hasClass('hidden')).toBeFalsy();
        expect($('.notificationapi-unread').html()).toEqual('1');
    });
    test('given 100, shows +99', function () {
        notificationapi.showInApp({
            root: 'root'
        });
        notificationapi.setInAppUnread(100);
        expect($('.notificationapi-unread').hasClass('hidden')).toBeFalsy();
        expect($('.notificationapi-unread').html()).toEqual('+99');
    });
});
describe('Handling WS_NotificationsResponse', function () {
    test('happening before showInApp, does not throw', function () {
        notificationapi = new NotificationAPI({
            clientId: clientId,
            userId: userId,
            websocket: false
        });
        notificationapi.websocketHandlers.notifications({
            route: 'inapp_web/notifications',
            payload: {
                notifications: [testNotification]
            }
        });
        expect(spy.mock.calls).toEqual([]);
    });
    test('defaults to loading state, no notifications or empty message', function () {
        notificationapi.showInApp({
            root: 'root'
        });
        expect($('.notificationapi-loading')).toHaveLength(1);
        expect($('.notificationapi-empty')).toHaveLength(0);
        expect($('.notificationapi-notification')).toHaveLength(0);
    });
    test('given 0 notifications, adds no notifications and shows empty, removes loading', function () {
        notificationapi.showInApp({
            root: 'root'
        });
        notificationapi.websocketHandlers.notifications({
            route: 'inapp_web/notifications',
            payload: {
                notifications: []
            }
        });
        expect($('.notificationapi-empty')).toHaveLength(1);
        expect($('.notificationapi-notification')).toHaveLength(0);
        expect($('.notificationapi-loading')).toHaveLength(0);
    });
    test('after showing empty, given any notifications, adds notification and removes empty/loading', function () {
        notificationapi.showInApp({
            root: 'root'
        });
        notificationapi.websocketHandlers.notifications({
            route: 'inapp_web/notifications',
            payload: {
                notifications: []
            }
        });
        expect($('.notificationapi-empty')).toHaveLength(1);
        expect($('.notificationapi-loading')).toHaveLength(0);
        expect($('.notificationapi-notification')).toHaveLength(0);
        notificationapi.websocketHandlers.notifications({
            route: 'inapp_web/notifications',
            payload: {
                notifications: [testNotification]
            }
        });
        expect($('.notificationapi-empty')).toHaveLength(0);
        expect($('.notificationapi-loading')).toHaveLength(0);
        expect($('.notificationapi-notification')).toHaveLength(1);
    });
    test('given 2, adds 2 notifications', function () {
        notificationapi.showInApp({
            root: 'root'
        });
        notificationapi.websocketHandlers.notifications({
            route: 'inapp_web/notifications',
            payload: {
                notifications: [testNotification, testNotificationUnseen]
            }
        });
        expect($('.notificationapi-notification')).toHaveLength(2);
    });
    test('given 1 notification, shows title, message, image and date with correct redirect', function () {
        notificationapi.showInApp({
            root: 'root'
        });
        notificationapi.websocketHandlers.notifications({
            route: 'inapp_web/notifications',
            payload: {
                notifications: [testNotification]
            }
        });
        expect($('.notificationapi-notification').attr('href')).toEqual(testNotification.redirectURL);
        expect($('.notificationapi-notification-title').text()).toEqual(testNotification.title);
        expect($('.notificationapi-notification-image').attr('src')).toEqual(testNotification.imageURL);
        expect($('.notificationapi-notification-date').text()).toEqual('just now');
    });
    describe('Relative times', function () {
        notificationWithDifferentTimes.map(function (notificationWithDifferentTime, index) {
            test("notification date with ".concat(timeCases_seconds[index], " milliseconds relative time difference shows as  ").concat(timeCasesResults[index]), function () {
                notificationapi.showInApp({
                    root: 'root'
                });
                notificationapi.websocketHandlers.notifications({
                    route: 'inapp_web/notifications',
                    payload: {
                        notifications: [notificationWithDifferentTime]
                    }
                });
                expect($('.notificationapi-notification-date').text()).toEqual(timeCasesResults[index]);
            });
        });
    });
    test('without url, does not redirect', function () {
        notificationapi.showInApp({
            root: 'root'
        });
        notificationapi.websocketHandlers.notifications({
            route: 'inapp_web/notifications',
            payload: {
                notifications: [testNotificationWithoutURL]
            }
        });
        expect($('.notificationapi-notification').attr('href')).toBeFalsy();
    });
    test('without image, ignores image, uses icon', function () {
        notificationapi.showInApp({
            root: 'root'
        });
        notificationapi.websocketHandlers.notifications({
            route: 'inapp_web/notifications',
            payload: {
                notifications: [testNotificationWithoutImage]
            }
        });
        expect($('.notificationapi-notification-image')).toHaveLength(0);
    });
    test('unseen notification has unseen class on it', function () {
        notificationapi.showInApp({
            root: 'root'
        });
        notificationapi.websocketHandlers.notifications({
            route: 'inapp_web/notifications',
            payload: {
                notifications: [testNotificationUnseen]
            }
        });
        expect($('.notificationapi-notification').hasClass('unseen')).toBeTruthy();
    });
    test('notifications with repeat ID are not added', function () {
        notificationapi.showInApp({
            root: 'root'
        });
        notificationapi.websocketHandlers.notifications({
            route: 'inapp_web/notifications',
            payload: {
                notifications: [testNotification]
            }
        });
        notificationapi.websocketHandlers.notifications({
            route: 'inapp_web/notifications',
            payload: {
                notifications: [testNotification]
            }
        });
        expect($('.notificationapi-notification')).toHaveLength(1);
    });
    test('incoming new notification is placed at the top', function () {
        notificationapi.showInApp({
            root: 'root'
        });
        notificationapi.websocketHandlers.notifications({
            route: 'inapp_web/notifications',
            payload: {
                notifications: [testNotification, testNotificationWithoutImage]
            }
        });
        notificationapi.websocketHandlers.notifications({
            route: 'inapp_web/notifications',
            payload: {
                notifications: [
                    __assign(__assign({}, testNotification), { date: new Date('2030-01-01').toISOString(), id: 'new' })
                ]
            }
        });
        expect($('.notificationapi-popup-inner')
            .children()[1]
            .getAttribute('data-notification-id')).toEqual('new');
    });
    test('incoming old notification is placed at the bottom', function () {
        notificationapi.showInApp({
            root: 'root'
        });
        notificationapi.websocketHandlers.notifications({
            route: 'inapp_web/notifications',
            payload: {
                notifications: [testNotification, testNotificationWithoutImage]
            }
        });
        notificationapi.websocketHandlers.notifications({
            route: 'inapp_web/notifications',
            payload: {
                notifications: [
                    __assign(__assign({}, testNotification), { date: new Date('2000-01-01').toISOString(), id: 'old' })
                ]
            }
        });
        expect($('.notificationapi-popup-inner')
            .children()[3]
            .getAttribute('data-notification-id')).toEqual('old');
    });
});
describe('websocket send & receives', function () {
    test('given WS is not open, requests for unread count and notifications after it is opened', function () { return __awaiter(void 0, void 0, void 0, function () {
        var req1, req2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, server.nextMessage];
                case 1:
                    _a.sent();
                    notificationapi.showInApp({
                        root: 'root'
                    });
                    req1 = {
                        route: 'inapp_web/unread_count'
                    };
                    req2 = {
                        route: 'inapp_web/notifications',
                        payload: {
                            count: 50
                        }
                    };
                    return [4, expect(server).toReceiveMessage(req1)];
                case 2:
                    _a.sent();
                    return [4, expect(server).toReceiveMessage(req2)];
                case 3:
                    _a.sent();
                    return [2];
            }
        });
    }); });
    test('given WS is open, requests for unread count and notifications', function () { return __awaiter(void 0, void 0, void 0, function () {
        var req1, req2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, server.connected];
                case 1:
                    _a.sent();
                    return [4, server.nextMessage];
                case 2:
                    _a.sent();
                    notificationapi.showInApp({
                        root: 'root'
                    });
                    req1 = {
                        route: 'inapp_web/unread_count'
                    };
                    req2 = {
                        route: 'inapp_web/notifications',
                        payload: {
                            count: 50
                        }
                    };
                    return [4, expect(server).toReceiveMessage(req1)];
                case 3:
                    _a.sent();
                    return [4, expect(server).toReceiveMessage(req2)];
                case 4:
                    _a.sent();
                    return [2];
            }
        });
    }); });
    test('given malformed message, doesnt break', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            notificationapi.showInApp({
                root: 'root'
            });
            server.send('test');
            expect(spy.mock.calls).toHaveLength(0);
            return [2];
        });
    }); });
    test('given WS_UnreadCountResponse, calls websocketHandlers.unreadCount', function () { return __awaiter(void 0, void 0, void 0, function () {
        var spy, res;
        return __generator(this, function (_a) {
            spy = jest.spyOn(notificationapi.websocketHandlers, 'unreadCount');
            notificationapi.showInApp({
                root: 'root'
            });
            res = {
                route: 'inapp_web/unread_count',
                payload: {
                    count: 3
                }
            };
            server.send(res);
            expect(spy).toHaveBeenCalledWith(res);
            return [2];
        });
    }); });
    test('given WS_NotificationsResponse, calls websocketHandlers.notifications', function () { return __awaiter(void 0, void 0, void 0, function () {
        var spy, res;
        return __generator(this, function (_a) {
            spy = jest.spyOn(notificationapi.websocketHandlers, 'notifications');
            notificationapi.showInApp({
                root: 'root'
            });
            res = {
                route: 'inapp_web/notifications',
                payload: {
                    notifications: []
                }
            };
            server.send(res);
            expect(spy).toHaveBeenCalledWith(res);
            return [2];
        });
    }); });
    test('given WS_NewNotificationsResponse, calls websocketHandlers.newNotifications', function () { return __awaiter(void 0, void 0, void 0, function () {
        var spy, res;
        return __generator(this, function (_a) {
            spy = jest.spyOn(notificationapi.websocketHandlers, 'newNotifications');
            notificationapi.showInApp({
                root: 'root'
            });
            res = {
                route: 'inapp_web/new_notifications',
                payload: {
                    notifications: []
                }
            };
            server.send(res);
            expect(spy).toHaveBeenCalledWith(res);
            return [2];
        });
    }); });
    test('given < 50 notifications, renders them and no more message', function () { return __awaiter(void 0, void 0, void 0, function () {
        var message;
        return __generator(this, function (_a) {
            notificationapi.showInApp({
                root: 'root'
            });
            message = {
                route: 'inapp_web/notifications',
                payload: { notifications: [testNotification, testNotificationUnseen] }
            };
            server.send(message);
            expect($('.notificationapi-notification')).toHaveLength(2);
            expect($('.notificationapi-nomore')).toHaveLength(1);
            return [2];
        });
    }); });
    test('given no notifications, renders empty state and not no more', function () { return __awaiter(void 0, void 0, void 0, function () {
        var message;
        return __generator(this, function (_a) {
            notificationapi.showInApp({
                root: 'root'
            });
            message = {
                route: 'inapp_web/notifications',
                payload: { notifications: [] }
            };
            server.send(message);
            expect($('.notificationapi-notification')).toHaveLength(0);
            expect($('.notificationapi-empty')).toHaveLength(1);
            expect($('.notificationapi-nomore')).toHaveLength(0);
            return [2];
        });
    }); });
    test('given new notifications (actual new and repeats), updates actual unread count on popup and shows actual new notificaitons in popup', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            notificationapi.showInApp({
                root: 'root'
            });
            notificationapi.websocketHandlers.notifications({
                route: 'inapp_web/notifications',
                payload: { notifications: [testNotification] }
            });
            notificationapi.websocketHandlers.unreadCount({
                route: 'inapp_web/unread_count',
                payload: { count: 1 }
            });
            notificationapi.websocketHandlers.newNotifications({
                route: 'inapp_web/new_notifications',
                payload: {
                    notifications: [
                        testNotification,
                        testNotificationUnseen,
                        testNotificationWithoutImage
                    ]
                }
            });
            expect($('.notificationapi-notification')).toHaveLength(3);
            expect($('.notificationapi-unread').text()).toEqual('3');
            return [2];
        });
    }); });
});
describe('paginated', function () {
    test('displays next/prev buttons', function () {
        notificationapi.showInApp({
            root: 'root',
            paginated: true
        });
        expect($('.notificationapi-footer > .notificationapi-prev-button:disabled')).toHaveLength(1);
        expect($('.notificationapi-footer > .notificationapi-next-button:disabled')).toHaveLength(1);
    });
    test('only displays first 5 notifications', function () {
        notificationapi.showInApp({
            root: 'root',
            paginated: true
        });
        notificationapi.websocketHandlers.notifications({
            route: 'inapp_web/notifications',
            payload: {
                notifications: generateFakeNotifications(15)
            }
        });
        expect($('.notificationapi-notification')).toHaveLength(5);
        expect($('[data-notification-id="fake-0"]')).toHaveLength(1);
        expect($('[data-notification-id="fake-4"]')).toHaveLength(1);
    });
    test('when next is clicked, shows the next 5', function () {
        var _a;
        notificationapi.showInApp({
            root: 'root',
            paginated: true
        });
        notificationapi.websocketHandlers.notifications({
            route: 'inapp_web/notifications',
            payload: {
                notifications: generateFakeNotifications(15)
            }
        });
        (_a = notificationapi.elements.nextButton) === null || _a === void 0 ? void 0 : _a.click();
        expect($('.notificationapi-notification')).toHaveLength(5);
        expect($('[data-notification-id="fake-5"]')).toHaveLength(1);
        expect($('[data-notification-id="fake-9"]')).toHaveLength(1);
    });
    test('when next is clicked, then prev is clicked, shows the first 5', function () {
        var _a, _b;
        notificationapi.showInApp({
            root: 'root',
            paginated: true
        });
        notificationapi.websocketHandlers.notifications({
            route: 'inapp_web/notifications',
            payload: {
                notifications: generateFakeNotifications(15)
            }
        });
        (_a = notificationapi.elements.nextButton) === null || _a === void 0 ? void 0 : _a.click();
        (_b = notificationapi.elements.prevButton) === null || _b === void 0 ? void 0 : _b.click();
        expect($('.notificationapi-notification')).toHaveLength(5);
        expect($('[data-notification-id="fake-0"]')).toHaveLength(1);
        expect($('[data-notification-id="fake-4"]')).toHaveLength(1);
    });
    test('prev & next are disabled page 1/1', function () {
        notificationapi.showInApp({
            root: 'root',
            paginated: true
        });
        notificationapi.websocketHandlers.notifications({
            route: 'inapp_web/notifications',
            payload: {
                notifications: generateFakeNotifications(5)
            }
        });
        expect($('.notificationapi-prev-button:disabled')).toHaveLength(1);
        expect($('.notificationapi-next-button:disabled')).toHaveLength(1);
    });
    test('next is enabled, prev is disabled page 1/3 pages', function () {
        notificationapi.showInApp({
            root: 'root',
            paginated: true
        });
        notificationapi.websocketHandlers.notifications({
            route: 'inapp_web/notifications',
            payload: {
                notifications: generateFakeNotifications(15)
            }
        });
        expect($('.notificationapi-prev-button:disabled')).toHaveLength(1);
        expect($('.notificationapi-next-button:not(:disabled)')).toHaveLength(1);
    });
    test('next & prev are enabled page 2/3 pages', function () {
        var _a;
        notificationapi.showInApp({
            root: 'root',
            paginated: true
        });
        notificationapi.websocketHandlers.notifications({
            route: 'inapp_web/notifications',
            payload: {
                notifications: generateFakeNotifications(15)
            }
        });
        (_a = notificationapi.elements.nextButton) === null || _a === void 0 ? void 0 : _a.click();
        expect($('.notificationapi-prev-button:not(:disabled)')).toHaveLength(1);
        expect($('.notificationapi-next-button:not(:disabled)')).toHaveLength(1);
    });
    test('next is disabled & prev is enabled page 3/3 pages', function () {
        var _a, _b;
        notificationapi.showInApp({
            root: 'root',
            paginated: true
        });
        notificationapi.websocketHandlers.notifications({
            route: 'inapp_web/notifications',
            payload: {
                notifications: generateFakeNotifications(15)
            }
        });
        (_a = notificationapi.elements.nextButton) === null || _a === void 0 ? void 0 : _a.click();
        (_b = notificationapi.elements.nextButton) === null || _b === void 0 ? void 0 : _b.click();
        expect($('.notificationapi-prev-button:not(:disabled)')).toHaveLength(1);
        expect($('.notificationapi-next-button:disabled')).toHaveLength(1);
    });
    test('uses pageSize for custom pagination page size', function () {
        notificationapi.showInApp({
            root: 'root',
            paginated: true,
            pageSize: 15
        });
        notificationapi.websocketHandlers.notifications({
            route: 'inapp_web/notifications',
            payload: {
                notifications: generateFakeNotifications(15)
            }
        });
        expect($('.notificationapi-next-button:disabled')).toHaveLength(1);
    });
    test('loads more notifications when it reaches one page before last', function () { return __awaiter(void 0, void 0, void 0, function () {
        var req3;
        var _a, _b, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    notificationapi.showInApp({
                        root: 'root',
                        paginated: true,
                        pageSize: 10
                    });
                    return [4, server.nextMessage];
                case 1:
                    _d.sent();
                    return [4, server.nextMessage];
                case 2:
                    _d.sent();
                    return [4, server.nextMessage];
                case 3:
                    _d.sent();
                    notificationapi.websocketHandlers.notifications({
                        route: 'inapp_web/notifications',
                        payload: {
                            notifications: __spreadArray(__spreadArray([], generateFakeNotifications(49), true), [
                                __assign(__assign({}, testNotification), { date: '1989-09-28T10:00:00.000Z' })
                            ], false)
                        }
                    });
                    expect(notificationapi.state.notifications).toHaveLength(50);
                    return [4, new Promise(function (resolve) { return setTimeout(resolve, 1000); })];
                case 4:
                    _d.sent();
                    (_a = notificationapi.elements.nextButton) === null || _a === void 0 ? void 0 : _a.click();
                    (_b = notificationapi.elements.nextButton) === null || _b === void 0 ? void 0 : _b.click();
                    (_c = notificationapi.elements.nextButton) === null || _c === void 0 ? void 0 : _c.click();
                    req3 = {
                        route: 'inapp_web/notifications',
                        payload: {
                            before: '1989-09-28T10:00:00.000Z',
                            count: 50
                        }
                    };
                    return [4, expect(server).toReceiveMessage(req3)];
                case 5:
                    _d.sent();
                    return [2];
            }
        });
    }); });
});
describe('setAsReadMode', function () {
    [MarkAsReadModes.MANUAL, MarkAsReadModes.MANUAL_AND_CLICK].map(function (mode) {
        describe('MANUAL & MANUAL_AND_CLICK', function () {
            test('given unread count/badge, when popup in opened, unread count/badge do not clear', function () { return __awaiter(void 0, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    notificationapi.showInApp({
                        root: 'root',
                        markAsReadMode: mode
                    });
                    notificationapi.websocketHandlers.unreadCount({
                        route: 'inapp_web/unread_count',
                        payload: {
                            count: 5
                        }
                    });
                    $('.notificationapi-button').trigger('click');
                    expect($('.notificationapi-unread').hasClass('hidden')).toBeFalsy();
                    expect($('.notificationapi-unread').html()).toEqual('5');
                    expect(notificationapi.state.unread).toEqual(5);
                    return [2];
                });
            }); });
            test('when mark all as read button is clicked, clear request is sent and count/badge is cleared, all notifications lose .unseen class, all notifications are set to seen', function () { return __awaiter(void 0, void 0, void 0, function () {
                var expectedMsg;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            notificationapi.showInApp({
                                root: 'root',
                                markAsReadMode: mode
                            });
                            return [4, server.nextMessage];
                        case 1:
                            _a.sent();
                            return [4, server.nextMessage];
                        case 2:
                            _a.sent();
                            return [4, server.nextMessage];
                        case 3:
                            _a.sent();
                            notificationapi.websocketHandlers.unreadCount({
                                route: 'inapp_web/unread_count',
                                payload: {
                                    count: 5
                                }
                            });
                            notificationapi.websocketHandlers.notifications({
                                route: 'inapp_web/notifications',
                                payload: {
                                    notifications: [testNotification, testNotificationUnseen]
                                }
                            });
                            $('.notificationapi-button').trigger('click');
                            $('.notificationapi-readAll-button').trigger('click');
                            expect($('.notificationapi-unread').hasClass('hidden')).toBeTruthy();
                            expect($('.notificationapi-unread').html()).toEqual('0');
                            expect(notificationapi.state.unread).toEqual(0);
                            expect(notificationapi.state.notifications.filter(function (n) { return !n.seen; })).toHaveLength(0);
                            expect($('.unseen')).toHaveLength(0);
                            expectedMsg = {
                                route: 'inapp_web/unread_clear'
                            };
                            return [4, expect(server).toReceiveMessage(expectedMsg)];
                        case 4:
                            _a.sent();
                            return [2];
                    }
                });
            }); });
            test('there is a menu button for all seen/unseen notifications', function () {
                notificationapi.showInApp({
                    root: 'root',
                    markAsReadMode: mode
                });
                notificationapi.websocketHandlers.notifications({
                    route: 'inapp_web/notifications',
                    payload: {
                        notifications: [testNotification, testNotificationUnseen]
                    }
                });
                expect($('[data-notification-id="4"] .notificationapi-notification-menu-button')).toHaveLength(1);
                expect($('[data-notification-id="1"] .notificationapi-notification-menu-button')).toHaveLength(1);
            });
            test('clicking menu button creates a menu, clicking the body deletes the menu but keeps the popup open', function () {
                notificationapi.showInApp({
                    root: 'root',
                    markAsReadMode: mode
                });
                notificationapi.websocketHandlers.notifications({
                    route: 'inapp_web/notifications',
                    payload: {
                        notifications: [testNotificationUnseen]
                    }
                });
                $('.notificationapi-button').trigger('click');
                $('.notificationapi-notification-menu-button').trigger('click');
                expect($('.notificationapi-notification-menu')).toHaveLength(1);
                $('body').trigger('click');
                expect($('.notificationapi-notification-menu')).toHaveLength(0);
                expect($('#root .notificationapi-popup.closed')).toHaveLength(0);
            });
            test('cannot have 2 menus open', function () {
                notificationapi.showInApp({
                    root: 'root',
                    markAsReadMode: mode
                });
                notificationapi.websocketHandlers.notifications({
                    route: 'inapp_web/notifications',
                    payload: {
                        notifications: [
                            testNotificationUnseen,
                            __assign(__assign({}, testNotificationUnseen), { id: '1' })
                        ]
                    }
                });
                $('.notificationapi-button').trigger('click');
                $('[data-notification-id="1"] .notificationapi-notification-menu-button').trigger('click');
                $('[data-notification-id="4"] .notificationapi-notification-menu-button').trigger('click');
                expect($('.notificationapi-notification-menu')).toHaveLength(1);
            });
            test('clicking "Mark as Read" menu item reduces unread count, sends a unread ws message and closes the menu but not popup', function () { return __awaiter(void 0, void 0, void 0, function () {
                var expectedMsg;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            notificationapi.showInApp({
                                root: 'root',
                                markAsReadMode: mode
                            });
                            return [4, server.nextMessage];
                        case 1:
                            _a.sent();
                            return [4, server.nextMessage];
                        case 2:
                            _a.sent();
                            notificationapi.websocketHandlers.unreadCount({
                                route: 'inapp_web/unread_count',
                                payload: {
                                    count: 5
                                }
                            });
                            notificationapi.websocketHandlers.notifications({
                                route: 'inapp_web/notifications',
                                payload: {
                                    notifications: [testNotificationUnseen]
                                }
                            });
                            $('.notificationapi-button').trigger('click');
                            $('.notificationapi-notification-menu-button').trigger('click');
                            expect($('.notificationapi-notification-menu')).toHaveLength(1);
                            $('.notificationapi-notification-menu-item').trigger('click');
                            expect($('.notificationapi-unread')[0].innerHTML).toEqual('4');
                            expect(notificationapi.state.unread).toEqual(4);
                            expect($('.notificationapi-notification-menu')).toHaveLength(0);
                            expect($('#root .notificationapi-popup.closed')).toHaveLength(0);
                            return [4, server.nextMessage];
                        case 3:
                            _a.sent();
                            expectedMsg = {
                                route: 'inapp_web/unread_clear',
                                payload: {
                                    notificationId: '4'
                                }
                            };
                            expect(server).toReceiveMessage(expectedMsg);
                            return [2];
                    }
                });
            }); });
        });
    });
    describe('MANUAL_AND_CLICK', function () {
        test('clicking an unseen notification reduces unread count, changes the notification ui, sends a unread ws message', function () { return __awaiter(void 0, void 0, void 0, function () {
            var expectedMsg;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        notificationapi.showInApp({
                            root: 'root',
                            markAsReadMode: MarkAsReadModes.MANUAL_AND_CLICK
                        });
                        return [4, server.nextMessage];
                    case 1:
                        _a.sent();
                        return [4, server.nextMessage];
                    case 2:
                        _a.sent();
                        notificationapi.websocketHandlers.unreadCount({
                            route: 'inapp_web/unread_count',
                            payload: {
                                count: 5
                            }
                        });
                        notificationapi.websocketHandlers.notifications({
                            route: 'inapp_web/notifications',
                            payload: {
                                notifications: [
                                    __assign(__assign({}, testNotificationUnseen), { seen: false })
                                ]
                            }
                        });
                        $('.notificationapi-button').trigger('click');
                        $('.notificationapi-notification-title').trigger('click');
                        expect($('.notificationapi-unread')[0].innerHTML).toEqual('4');
                        expect(notificationapi.state.unread).toEqual(4);
                        expect($('.notificationapi-notification-menu')).toHaveLength(0);
                        return [4, server.nextMessage];
                    case 3:
                        _a.sent();
                        expectedMsg = {
                            route: 'inapp_web/unread_clear',
                            payload: {
                                notificationId: '4'
                            }
                        };
                        expect(server).toReceiveMessage(expectedMsg);
                        $('.notificationapi-notification-title').trigger('click');
                        expect($('.notificationapi-unread')[0].innerHTML).toEqual('4');
                        expect(notificationapi.state.unread).toEqual(4);
                        return [2];
                }
            });
        }); });
        test('clicking a seen notification doesnt do the above', function () { return __awaiter(void 0, void 0, void 0, function () {
            var expectedMsg;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        notificationapi.showInApp({
                            root: 'root',
                            markAsReadMode: MarkAsReadModes.MANUAL_AND_CLICK
                        });
                        return [4, server.nextMessage];
                    case 1:
                        _a.sent();
                        return [4, server.nextMessage];
                    case 2:
                        _a.sent();
                        notificationapi.websocketHandlers.unreadCount({
                            route: 'inapp_web/unread_count',
                            payload: {
                                count: 5
                            }
                        });
                        notificationapi.websocketHandlers.notifications({
                            route: 'inapp_web/notifications',
                            payload: {
                                notifications: [
                                    __assign(__assign({}, testNotificationUnseen), { seen: true })
                                ]
                            }
                        });
                        $('.notificationapi-button').trigger('click');
                        $('.notificationapi-notification-title').trigger('click');
                        expect($('.notificationapi-unread')[0].innerHTML).toEqual('5');
                        expect(notificationapi.state.unread).toEqual(5);
                        expect($('.notificationapi-notification-menu')).toHaveLength(0);
                        return [4, server.nextMessage];
                    case 3:
                        _a.sent();
                        expectedMsg = {
                            route: 'inapp_web/unread_clear',
                            payload: {
                                notificationId: '4'
                            }
                        };
                        expect(server).toReceiveMessage(expectedMsg);
                        return [2];
                }
            });
        }); });
    });
});
