var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import $ from 'jquery';
import WS from 'jest-websocket-mock';
import NotificationAPI from '../index';
var clientId = 'envId@';
var userId = 'userId@';
var spy;
var notificationapi;
var server;
var emailInAppPreference = {
    notificationId: 'notificationId1',
    title: 'title1',
    settings: [
        {
            channel: 'EMAIL',
            channelName: 'Email',
            state: true
        },
        {
            channel: 'INAPP_WEB',
            channelName: 'In-App (Web)',
            state: false
        }
    ]
};
var inappSMSPreference = {
    notificationId: 'notificationId2',
    title: 'title2',
    settings: [
        {
            channel: 'INAPP_WEB',
            channelName: 'In-App (Web)',
            state: false
        },
        {
            channel: 'SMS',
            channelName: 'SMS',
            state: true
        }
    ]
};
beforeEach(function () {
    spy = jest.spyOn(console, 'error').mockImplementation();
    document.body.innerHTML = '<div id="root"></div><div id="root2"></div>';
    Object.defineProperty(window, 'innerWidth', {
        writable: true,
        configurable: true,
        value: 1600
    });
    server = new WS('ws://localhost:1234', { jsonProtocol: true });
    notificationapi = new NotificationAPI({
        clientId: clientId,
        userId: userId,
        websocket: 'ws://localhost:1234'
    });
});
afterEach(function () {
    WS.clean();
    spy.mockRestore();
    jest.restoreAllMocks();
    if (notificationapi)
        notificationapi.destroy();
});
describe('default elements and interactions', function () {
    test('adds the a notificationapi preferences container to the body', function () {
        notificationapi.showUserPreferences();
        expect($('body > div[class="notificationapi-preferences-container"]')).toHaveLength(1);
    });
    test('adds a backdrop to the container', function () {
        notificationapi.showUserPreferences();
        expect($('div[class="notificationapi-preferences-container"] > .notificationapi-preferences-backdrop')).toHaveLength(1);
    });
    test('when backdrop is clicked, container gets .closed', function () {
        notificationapi.showUserPreferences();
        $('.notificationapi-preferences-backdrop').trigger('click');
        expect($('.notificationapi-preferences-container.closed')).toHaveLength(1);
    });
    test('running showUserPreferences() again removes .closed without recreating elements', function () {
        notificationapi.showUserPreferences();
        $('.notificationapi-preferences-backdrop').trigger('click');
        notificationapi.showUserPreferences();
        expect($('.notificationapi-preferences-container.closed')).toHaveLength(0);
        expect($('.notificationapi-preferences-container')).toHaveLength(1);
    });
    test('adds a popup to the container', function () {
        notificationapi.showUserPreferences();
        expect($('.notificationapi-preferences-container > .notificationapi-preferences-popup')).toHaveLength(1);
    });
    test('adds a close button to the popup', function () {
        notificationapi.showUserPreferences();
        expect($('.notificationapi-preferences-popup > button[class="notificationapi-preferences-close"]')).toHaveLength(1);
    });
    test('when close button is clicked, container gets .closed', function () {
        notificationapi.showUserPreferences();
        $('.notificationapi-preferences-close').trigger('click');
        expect($('.notificationapi-preferences-container.closed')).toHaveLength(1);
    });
    test('adds loading animation to the popup', function () {
        notificationapi.showUserPreferences();
        expect($('.notificationapi-preferences-popup > .notificationapi-loading')).toHaveLength(1);
    });
    test('when askForWebPushPermission is true the web push permission opt in message is added', function () { return __awaiter(void 0, void 0, void 0, function () {
        var res;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, server.connected];
                case 1:
                    _a.sent();
                    res = {
                        route: 'environment/data',
                        payload: {
                            logo: 'string',
                            applicationServerKey: 'string',
                            askForWebPushPermission: true
                        }
                    };
                    server.send(res);
                    notificationapi.showUserPreferences();
                    notificationapi.renderPreferences([emailInAppPreference]);
                    expect($('.notificationapi-preferences-popup > .notificationapi-preferences-web-push-opt-in')).toHaveLength(1);
                    return [2];
            }
        });
    }); });
    test('when askForWebPushPermission is true the web push permission message is clicked and askForWebPushPermission is called', function () { return __awaiter(void 0, void 0, void 0, function () {
        var mockAskForWebPushPermission, res;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    mockAskForWebPushPermission = jest.spyOn(notificationapi, 'askForWebPushPermission');
                    return [4, server.connected];
                case 1:
                    _a.sent();
                    res = {
                        route: 'environment/data',
                        payload: {
                            logo: 'string',
                            applicationServerKey: 'string',
                            askForWebPushPermission: true
                        }
                    };
                    server.send(res);
                    notificationapi.showUserPreferences();
                    notificationapi.renderPreferences([emailInAppPreference]);
                    $('.notificationapi-preferences-web-push-opt-in').trigger('click');
                    expect(mockAskForWebPushPermission).toHaveBeenCalled();
                    return [2];
            }
        });
    }); });
});
describe('inline mode', function () {
    test('gives an error when parent does not exist', function () {
        notificationapi.showUserPreferences({ parent: 'does-not-exist-id' });
        expect(spy.mock.calls).toEqual([
            ['There are no HTML elements with id="does-not-exist-id" on the page.']
        ]);
    });
    test('adds the notificationapi preferences container to the parent div with an inline style', function () {
        notificationapi.showUserPreferences({ parent: 'root' });
        expect($('body > div#root > div[class="notificationapi-preferences-container inline"]')).toHaveLength(1);
    });
});
describe('websocket send & receives', function () {
    test('given no WS, throws no error', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            notificationapi = new NotificationAPI({
                clientId: clientId,
                userId: userId,
                websocket: false
            });
            notificationapi.showUserPreferences();
            expect(spy.mock.calls).toEqual([]);
            return [2];
        });
    }); });
    test('given WS is not open, requests user_preferences after it is opened', function () { return __awaiter(void 0, void 0, void 0, function () {
        var req1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, server.nextMessage];
                case 1:
                    _a.sent();
                    notificationapi.showUserPreferences();
                    req1 = {
                        route: 'user_preferences/get_preferences'
                    };
                    return [4, expect(server).toReceiveMessage(req1)];
                case 2:
                    _a.sent();
                    return [2];
            }
        });
    }); });
    test('given WS is open, requests user_preferences', function () { return __awaiter(void 0, void 0, void 0, function () {
        var req1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, server.connected];
                case 1:
                    _a.sent();
                    return [4, server.nextMessage];
                case 2:
                    _a.sent();
                    notificationapi.showUserPreferences();
                    req1 = {
                        route: 'user_preferences/get_preferences'
                    };
                    return [4, expect(server).toReceiveMessage(req1)];
                case 3:
                    _a.sent();
                    return [2];
            }
        });
    }); });
    test('given malformed message, doesnt break', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            notificationapi.showUserPreferences();
            server.send('test');
            expect(spy.mock.calls).toHaveLength(0);
            return [2];
        });
    }); });
    test('given preferences, calls renderPreferences function with preference objects', function () { return __awaiter(void 0, void 0, void 0, function () {
        var mock, res;
        return __generator(this, function (_a) {
            mock = jest.spyOn(notificationapi, 'renderPreferences');
            notificationapi.showUserPreferences();
            res = {
                route: 'user_preferences/preferences',
                payload: {
                    userPreferences: [
                        {
                            notificationId: 'test-notificationId',
                            title: 'test-title',
                            settings: []
                        }
                    ]
                }
            };
            server.send(res);
            expect(mock).toHaveBeenCalledWith(res.payload.userPreferences);
            return [2];
        });
    }); });
    test('given other messages, does not call renderPreferences', function () { return __awaiter(void 0, void 0, void 0, function () {
        var mock, res;
        return __generator(this, function (_a) {
            mock = jest.spyOn(notificationapi, 'renderPreferences');
            notificationapi.showUserPreferences();
            res = {
                route: 'inapp_web/unread_count',
                payload: {
                    count: 50
                }
            };
            server.send(res);
            expect(mock).toHaveBeenCalledTimes(0);
            return [2];
        });
    }); });
    test('given preference, clicking toggle changes the toggle and sends correct patch request', function () { return __awaiter(void 0, void 0, void 0, function () {
        var req1, req2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    notificationapi.showUserPreferences();
                    return [4, server.nextMessage];
                case 1:
                    _a.sent();
                    return [4, server.nextMessage];
                case 2:
                    _a.sent();
                    notificationapi.renderPreferences([emailInAppPreference]);
                    $('.notificationapi-preferences-toggle[data-channel="EMAIL"] input').trigger('click');
                    req1 = {
                        route: 'user_preferences/patch_preferences',
                        payload: [
                            {
                                notificationId: emailInAppPreference.notificationId,
                                channelPreferences: [
                                    {
                                        channel: 'EMAIL',
                                        state: false
                                    }
                                ]
                            }
                        ]
                    };
                    expect($('.notificationapi-preferences-toggle[data-channel="EMAIL"] input:not(:checked)')).toHaveLength(1);
                    return [4, expect(server).toReceiveMessage(req1)];
                case 3:
                    _a.sent();
                    $('.notificationapi-preferences-toggle[data-channel="EMAIL"] input').trigger('click');
                    req2 = {
                        route: 'user_preferences/patch_preferences',
                        payload: [
                            {
                                notificationId: emailInAppPreference.notificationId,
                                channelPreferences: [
                                    {
                                        channel: 'EMAIL',
                                        state: true
                                    }
                                ]
                            }
                        ]
                    };
                    expect($('.notificationapi-preferences-toggle[data-channel="EMAIL"] input:checked')).toHaveLength(1);
                    return [4, expect(server).toReceiveMessage(req2)];
                case 4:
                    _a.sent();
                    return [2];
            }
        });
    }); });
    test('given preference, clicking subtoggle changes the subtoggle and sends correct patch request', function () { return __awaiter(void 0, void 0, void 0, function () {
        var res, req, req2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    notificationapi.showUserPreferences();
                    return [4, expect(server).toReceiveMessage({ route: 'environment/data' })];
                case 1:
                    _a.sent();
                    res = {
                        route: 'environment/data',
                        payload: {
                            logo: '',
                            applicationServerKey: '',
                            askForWebPushPermission: true
                        }
                    };
                    server.send(res);
                    return [4, server.nextMessage];
                case 2:
                    _a.sent();
                    notificationapi.renderPreferences([
                        __assign(__assign({}, emailInAppPreference), { subNotificationPreferences: [
                                __assign(__assign({}, emailInAppPreference), { subNotificationId: 'subNotificationId1', title: 'subtitle1' })
                            ] })
                    ]);
                    $('.notificationapi-preferences-subtoggle[data-channel="EMAIL"] input').trigger('click');
                    req = {
                        route: 'user_preferences/patch_preferences',
                        payload: [
                            {
                                notificationId: emailInAppPreference.notificationId,
                                subNotificationId: 'subNotificationId1',
                                channelPreferences: [
                                    {
                                        channel: 'EMAIL',
                                        state: false
                                    }
                                ]
                            }
                        ]
                    };
                    expect($('.notificationapi-preferences-subtoggle[data-channel="EMAIL"] input:not(:checked)')).toHaveLength(1);
                    return [4, expect(server).toReceiveMessage(req)];
                case 3:
                    _a.sent();
                    $('.notificationapi-preferences-subtoggle[data-channel="EMAIL"] input').trigger('click');
                    req2 = {
                        route: 'user_preferences/patch_preferences',
                        payload: [
                            {
                                notificationId: emailInAppPreference.notificationId,
                                subNotificationId: 'subNotificationId1',
                                channelPreferences: [
                                    {
                                        channel: 'EMAIL',
                                        state: true
                                    }
                                ]
                            }
                        ]
                    };
                    expect($('.notificationapi-preferences-subtoggle[data-channel="EMAIL"] input:checked')).toHaveLength(1);
                    return [4, expect(server).toReceiveMessage(req2)];
                case 4:
                    _a.sent();
                    return [2];
            }
        });
    }); });
});
describe('renderPreferences', function () {
    test('before showUserPreferences(), does not throw', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            notificationapi.renderPreferences([]);
            expect(spy.mock.calls).toEqual([]);
            return [2];
        });
    }); });
    test('given no preferences, removes loading & renders empty state', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            notificationapi.showUserPreferences();
            notificationapi.renderPreferences([]);
            expect($('.notification-loading')).toHaveLength(0);
            expect($('.notificationapi-preferences-popup > .notificationapi-preferences-empty')).toHaveLength(1);
            return [2];
        });
    }); });
    test('given empty preferences repeatedly, removes loading & shows one empty state', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            notificationapi.showUserPreferences();
            notificationapi.renderPreferences([]);
            notificationapi.renderPreferences([]);
            expect($('.notification-loading')).toHaveLength(0);
            expect($('.notificationapi-preferences-popup > .notificationapi-preferences-empty')).toHaveLength(1);
            return [2];
        });
    }); });
    test('given preference without channel, removes loading & shows empty state)', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            notificationapi.showUserPreferences();
            notificationapi.renderPreferences([
                {
                    notificationId: 'test-notificationId',
                    title: 'test-title',
                    settings: []
                }
            ]);
            expect($('.notification-loading')).toHaveLength(0);
            expect($('.notificationapi-preferences-popup > .notificationapi-preferences-empty')).toHaveLength(1);
            return [2];
        });
    }); });
    test('given preference, adds grid to popup', function () {
        notificationapi.showUserPreferences();
        notificationapi.renderPreferences([emailInAppPreference]);
        expect($('.notificationapi-preferences-popup > .notificationapi-preferences-grid')).toHaveLength(1);
    });
    test('given preference, adds grid to popup, no askForWebPushPermission', function () {
        notificationapi.showUserPreferences();
        notificationapi.renderPreferences([emailInAppPreference]);
        expect($('.notificationapi-preferences-popup > .notificationapi-preferences-grid')).toHaveLength(1);
        expect($('.notificationapi-preferences-popup > .notificationapi-preferences-message')).toHaveLength(0);
    });
    test("given email/inapp and inapp/sms preference, adds email/inapp/sms headers to grid", function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            notificationapi.showUserPreferences();
            notificationapi.renderPreferences([
                emailInAppPreference,
                inappSMSPreference
            ]);
            expect($('.notificationapi-preferences-grid > .notificationapi-preferences-channel')).toHaveLength(3);
            expect($('.notificationapi-preferences-channel.notificationapi-preferences-col2.notificationapi-preferences-row1')[0].innerHTML).toEqual('Email');
            expect($('.notificationapi-preferences-channel.notificationapi-preferences-col3.notificationapi-preferences-row1')[0].innerHTML).toEqual('In-App (Web)');
            expect($('.notificationapi-preferences-channel.notificationapi-preferences-col4.notificationapi-preferences-row1')[0].innerHTML).toEqual('SMS');
            return [2];
        });
    }); });
    test("given two simple preferences, adds titles and toggles based on channel state to grid", function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            notificationapi.showUserPreferences();
            notificationapi.renderPreferences([
                emailInAppPreference,
                inappSMSPreference
            ]);
            expect($('.notificationapi-preferences-grid > .notificationapi-preferences-title')).toHaveLength(2);
            expect($('.notificationapi-preferences-title')[0].innerHTML).toEqual('title1');
            expect($('.notificationapi-preferences-title')[1].innerHTML).toEqual('title2');
            expect($('.notificationapi-preferences-grid > .notificationapi-preferences-toggle')).toHaveLength(4);
            expect($('.notificationapi-preferences-toggle.notificationapi-preferences-col2.notificationapi-preferences-row2[data-notificationId="notificationId1"][data-channel="EMAIL"] input:checked')).toHaveLength(1);
            expect($('.notificationapi-preferences-toggle.notificationapi-preferences-col3.notificationapi-preferences-row2[data-notificationId="notificationId1"][data-channel="INAPP_WEB"] input:not(:checked)')).toHaveLength(1);
            expect($('.notificationapi-preferences-toggle.notificationapi-preferences-col3.notificationapi-preferences-row3[data-notificationId="notificationId2"][data-channel="INAPP_WEB"] input:not(:checked)')).toHaveLength(1);
            expect($('.notificationapi-preferences-toggle.notificationapi-preferences-col4.notificationapi-preferences-row3[data-notificationId="notificationId2"][data-channel="SMS"] input:checked')).toHaveLength(1);
            return [2];
        });
    }); });
    test('does not show expand button if subNotificationPreferences is empty', function () {
        notificationapi.showUserPreferences();
        notificationapi.renderPreferences([
            __assign(__assign({}, emailInAppPreference), { subNotificationPreferences: [] })
        ]);
        expect($('.notificationapi-preferences-grid > .notificationapi-preferences-expand')).toHaveLength(0);
    });
    test("given a complex preference, adds expand button, subtitles and subtoggles to grid", function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            notificationapi.showUserPreferences();
            notificationapi.renderPreferences([
                __assign(__assign({}, emailInAppPreference), { subNotificationPreferences: [
                        __assign(__assign({}, emailInAppPreference), { subNotificationId: 'subNotificationId1', title: 'subtitle1' }),
                        __assign(__assign({}, emailInAppPreference), { subNotificationId: 'subNotificationId2', title: 'subtitle2' })
                    ] })
            ]);
            expect($('.notificationapi-preferences-grid > .notificationapi-preferences-expand')).toHaveLength(1);
            expect($('.notificationapi-preferences-grid > .notificationapi-preferences-subtitle')).toHaveLength(2);
            expect($('.notificationapi-preferences-subtitle')[0].innerHTML).toEqual('subtitle1');
            expect($('.notificationapi-preferences-subtitle')[1].innerHTML).toEqual('subtitle2');
            expect($('.notificationapi-preferences-grid > .notificationapi-preferences-subtoggle')).toHaveLength(4);
            expect($('.notificationapi-preferences-subtoggle.notificationapi-preferences-col2.notificationapi-preferences-row3[data-notificationId="notificationId1"][data-subNotificationId="subNotificationId1"][data-channel="EMAIL"] input:checked')).toHaveLength(1);
            expect($('.notificationapi-preferences-subtoggle.notificationapi-preferences-col3.notificationapi-preferences-row3[data-notificationId="notificationId1"][data-subNotificationId="subNotificationId1"][data-channel="INAPP_WEB"] input:not(:checked)')).toHaveLength(1);
            expect($('.notificationapi-preferences-subtoggle.notificationapi-preferences-col2.notificationapi-preferences-row4[data-notificationId="notificationId1"][data-subNotificationId="subNotificationId2"][data-channel="EMAIL"] input:checked')).toHaveLength(1);
            expect($('.notificationapi-preferences-subtoggle.notificationapi-preferences-col3.notificationapi-preferences-row4[data-notificationId="notificationId1"][data-subNotificationId="subNotificationId2"][data-channel="INAPP_WEB"] input:not(:checked)')).toHaveLength(1);
            return [2];
        });
    }); });
    test("subtitles and subtoggles are .closed by default", function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            notificationapi.showUserPreferences();
            notificationapi.renderPreferences([
                __assign(__assign({}, emailInAppPreference), { subNotificationPreferences: [
                        __assign(__assign({}, emailInAppPreference), { subNotificationId: 'subNotificationId1', title: 'subtitle1' })
                    ] })
            ]);
            expect($('.notificationapi-preferences-subtitle.closed')).toHaveLength(1);
            expect($('.notificationapi-preferences-subtoggle.closed')).toHaveLength(2);
            return [2];
        });
    }); });
    test("after expand is clicked, relevant subtitles and subtoggles lose .closed", function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            notificationapi.showUserPreferences();
            notificationapi.renderPreferences([
                __assign(__assign({}, emailInAppPreference), { subNotificationPreferences: [
                        __assign(__assign({}, emailInAppPreference), { subNotificationId: 'subNotificationId1', title: 'subtitle1' }),
                        __assign(__assign({}, emailInAppPreference), { subNotificationId: 'subNotificationId2', title: 'subtitle2' })
                    ] }),
                __assign(__assign({}, inappSMSPreference), { subNotificationPreferences: [
                        __assign(__assign({}, inappSMSPreference), { subNotificationId: 'subNotificationId1', title: 'subtitle3' }),
                        __assign(__assign({}, inappSMSPreference), { subNotificationId: 'subNotificationId2', title: 'subtitle4' })
                    ] })
            ]);
            $('.notificationapi-preferences-expand[data-notificationId="notificationId1"]').trigger('click');
            expect($('.notificationapi-preferences-subtitle[data-notificationId="notificationId1"]:not(.closed)')).toHaveLength(2);
            expect($('.notificationapi-preferences-subtoggle[data-notificationId="notificationId1"]:not(.closed)')).toHaveLength(4);
            expect($('.notificationapi-preferences-subtitle[data-notificationId="notificationId2"].closed')).toHaveLength(2);
            expect($('.notificationapi-preferences-subtoggle[data-notificationId="notificationId2"].closed')).toHaveLength(4);
            return [2];
        });
    }); });
    test('subtoggles are active for enabled notifications and inactive for disabled notifications', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            notificationapi.showUserPreferences();
            notificationapi.renderPreferences([
                __assign(__assign({}, emailInAppPreference), { subNotificationPreferences: [
                        __assign(__assign({}, emailInAppPreference), { subNotificationId: 'subNotificationId1', title: 'subtitle1' })
                    ] })
            ]);
            expect($('.notificationapi-preferences-subtoggle input:disabled')).toHaveLength(1);
            expect($('.notificationapi-preferences-subtoggle input:not(:disabled)')).toHaveLength(1);
            return [2];
        });
    }); });
    test('clicking toggle changes the disabled state of subtoggles', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            notificationapi.showUserPreferences();
            notificationapi.renderPreferences([
                __assign(__assign({}, emailInAppPreference), { subNotificationPreferences: [
                        __assign(__assign({}, emailInAppPreference), { subNotificationId: 'subNotificationId1', title: 'subtitle1' })
                    ] })
            ]);
            $('.notificationapi-preferences-toggle[data-channel="EMAIL"] input').trigger('click');
            expect($('.notificationapi-preferences-subtoggle[data-channel="EMAIL"] input:disabled')).toHaveLength(1);
            $('.notificationapi-preferences-toggle[data-channel="EMAIL"] input').trigger('click');
            expect($('.notificationapi-preferences-subtoggle[data-channel="EMAIL"] input:not(:disabled)')).toHaveLength(1);
            return [2];
        });
    }); });
    test("given preferences repeatedly, removes old preferences and renders new preferences", function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            notificationapi.showUserPreferences();
            notificationapi.renderPreferences([emailInAppPreference]);
            expect($('.notificationapi-preferences-title')[0].innerHTML).toEqual('title1');
            notificationapi.renderPreferences([inappSMSPreference]);
            expect($('.notificationapi-preferences-title')[0].innerHTML).toEqual('title2');
            return [2];
        });
    }); });
});
describe('When webPushSettings handler is triggered', function () {
    var originalNotification;
    beforeEach(function () {
        originalNotification = global.Notification;
        Object.defineProperty(global, 'Notification', {
            value: {
                permission: 'granted'
            },
            writable: true
        });
    });
    afterEach(function () {
        global.Notification = originalNotification;
    });
});
