var timeAgo = function (timeDifference, i18nInstance) {
    if (timeDifference < 0) {
        return i18nInstance.t('just_now');
    }
    else {
        var seconds = Math.round(timeDifference) / 1000;
        var minutes = Math.round(seconds / 60);
        var hours = Math.round(seconds / (60 * 60));
        var days = Math.round(seconds / (60 * 60 * 24));
        var months = Math.round(seconds / (60 * 60 * 24 * 30));
        var years = Math.round(seconds / (60 * 60 * 24 * 30 * 365.25));
        if (years > 0) {
            return "".concat(years, " ").concat(years === 1 ? i18nInstance.t('year') : i18nInstance.t('years'), " ").concat(i18nInstance.t('ago'));
        }
        else if (months > 0) {
            return "".concat(months, " ").concat(months === 1 ? i18nInstance.t('month') : i18nInstance.t('months'), " ").concat(i18nInstance.t('ago'));
        }
        else if (days > 0) {
            return "".concat(days, " ").concat(days === 1 ? i18nInstance.t('day') : i18nInstance.t('days'), " ").concat(i18nInstance.t('ago'));
        }
        else if (hours > 0) {
            return "".concat(hours, " ").concat(hours === 1 ? i18nInstance.t('hour') : i18nInstance.t('hours'), " ").concat(i18nInstance.t('ago'));
        }
        else if (minutes > 0) {
            return "".concat(minutes, " ").concat(minutes === 1 ? i18nInstance.t('minute') : i18nInstance.t('minutes'), " ").concat(i18nInstance.t('ago'));
        }
        else {
            return i18nInstance.t('just_now');
        }
    }
};
export default timeAgo;
